# PsPIN/OSMOSIS

## Running the code with Docker
1) `$ git clone git@spclgitlab.ethz.ch:mkhalilov/pspin-osmosis.git`
2) `$ cd ./pspin-osmosis/ && git submodule update --init --recursive`
3) `$ docker-compose up -d`
4) `$ docker ps # get the containerID`
5) `$ docker exec -it <containerID> bash`
6) `$ cd /opt/pspin/`
7) 
``` 
    $ cat sourceme-template.sh | \ 
    sed "s%RISCV_GCC=%RISCV_GCC=/tools/riscv-gcc/bin/%g" | \
    sed "s%PSPIN_HW=%PSPIN_HW=/opt/pspin/hw/%g" | \
    sed "s%PSPIN_RT=%PSPIN_RT=/opt/pspin/sw%g" > sourceme.sh
```

8) `$ source ./sourceme.sh`
9) `$ cd ./hw/verilator_model/`
10) `$ VERILATOR_COMPILER_WORKERS=$(nproc) make release`
11) `$ cd ../../examples/empty/`
12) `$ make deploy && make driver`
13) `$ make run`
